#ifndef NULL
#define NULL 0
#endif
#define DELETED -2

int triangulate, sorted, plot, debug;

struct Freenode
{
	struct Freenode *nextfree;
};

struct Freelist
{
	struct Freenode *head;
	int             nodesize;
};

void ref(struct Site* v);
void deref(struct Site* v);
void freeinit(struct Freelist * fl, int size);
void *getfree(struct Freelist* fl);
void makefree(struct Freenode* curr, struct Freelist* fl);
void *myalloc(unsigned n);

float xmin, xmax, ymin, ymax, deltax, deltay;


struct Point
{
	float x, y;
};

/* structure used both for sites and for vertices */
struct Site
{
	struct Point    coord;
	int sitenbr;
	int refcnt;
};


struct Site    *sites;
int nsites;
int siteidx;
int sqrt_nsites;
int nvertices;
struct Freelist sfl;
struct Site    *bottomsite;


struct Edge
{
	float           a, b, c;
	struct Site    *ep[2];
	struct Site    *reg[2];
	int             edgenbr;
};
#define le 0
#define re 1

int nedges;
struct Freelist efl;

int has_endpoint();
int right_of(struct Halfedge* el, struct Point* p);
float dist(struct Site* s, struct Site* t);
void makevertex(struct Site* v);
struct Point    PQ_min();
struct Halfedge *PQextractmin();
struct Edge* bisect(struct Site* s1, struct Site* s2);
struct Site* intersect(struct Halfedge* el1, struct Halfedge* el2 );
void endpoint(struct Edge* e, int lr, struct Site* s);
void PQinsert(struct Halfedge* he, struct Site* v, float offset);
void PQdelete(struct Halfedge* he);

struct Halfedge
{
	struct Halfedge *ELleft, *ELright;
	struct Edge    *ELedge;
	int             ELrefcnt;
	char            ELpm;
	struct Site    *vertex;
	float           ystar;
	struct Halfedge *PQnext;
};

struct Freelist hfl;
struct Halfedge *ELleftend, *ELrightend;
int ELhashsize;
struct Halfedge **ELhash;

void ELinsert ( struct Halfedge* lb, struct Halfedge* newH);
void ELdelete(struct Halfedge* he);
struct Halfedge * HEcreate(struct Edge* e, int pm);
struct Halfedge* ELleftbnd(struct Point* p);
struct Site* rightreg(struct Halfedge* he);
struct Site* leftreg(struct Halfedge* he);
struct Halfedge* ELleft(struct Halfedge* he);
struct Halfedge* ELright(struct Halfedge* he);


int PQhashsize;
struct Halfedge *PQhash;
struct Halfedge *PQfind();
int PQcount;
int PQmin;
int PQempty();

void PQinitialize();
void ELinitialize();

void out_bisector(struct Edge* e);
void out_ep(struct Edge* e);
void out_vertex(struct Site* v);
void out_site(struct Site* s);
void out_triple(struct Site* s1, struct Site* s2, struct Site* s3);
void plotinit();

typedef struct Site * FunctionType();

void voronoi(int triangulate, FunctionType nextsite);
void voronoiStart(int triangulate, FunctionType nextsite);
int voronoiLoop();
void voronoiEnd();
